/*
 *	The BSL Compiler Kit
 *	A Portable BSL-Compiler, C-Version
 *	Copyright (C) 1995 Nils M. Holm
 *
 *	PUBLIC GLOBALS
 *
 *	These variables are shared between all modules.
 */

extern int	Token;				/* Current token */
extern int	Value;				/* Value of curr. token */
extern char	Strval[TOKLEN+1];		/* Text of curr. token */

extern char	Buffer[BUFLEN+TOKLEN+2];	/* Input buffer */
extern int	Bp;				/* Buffer pointer */
extern int	Btop;				/* Buffer watermark */

extern int	Infile, Outfile;		/* Input/output files */
extern char	Inname[PATHL], *Outname;	/* Names of the above */

extern int	Lno;				/* Current input line no */
extern int	Errcount;			/* Error counter */

extern int	Level;				/* Current nesting level */
extern uint	Dtop,				/* Top of static data seg */
		Ftop;				/* Top of stack frame */

extern int	Forwtab[MAXFORW],		/* Forward table */
		Forwp;				/* Pointer to last FORWARD */

extern struct node	*Nodes;			/* Node pool */
extern int	Nsize;				/* # of nodes in pool */

extern struct syment	*Symbols;		/* Symbol table */
extern int	St0,				/* Top of global symbols */
		St1,				/* Bot. of local symbols */
		Stsize;				/* # of symbol tbl entries */

extern int	O_debug,			/* Opt: debugging on/off */
		O_opt,				/* Opt: optimizing on/off */
		O_linfo;			/* Dbg: include line nums */
