/*
 *	The BSL Compiler Kit
 *	com2img -- Generate BCODE images from executables
 *	Copyright (C) 1995 Nils M. Holm
 *
 *	com2img is used to convert an MSDOS *.com-style executable
 *	into a list of decimal numbers preceded by an IMG
 *	instruction.
 *	This is required to build the BSL startup module 'B0'.
 */

#include <stdio.h>
#include <fcntl.h>


#define MAXBYTES	4096


main() {
	FILE	*in = stdin, *out = stdout;
	static unsigned int	buf[MAXBYTES];
	int	i, c, lc, bp;

	setmode(fileno(in), O_BINARY);
	setmode(fileno(out), O_BINARY);
	fputs("IMG ", out);
	bp = 1;
	c = fgetc(in);
	while (!feof(in)) {
		buf[bp++] = c;
		if (bp >= MAXBYTES) {
			fprintf(stderr, "error: input file too long\n");
			exit(1);
		}
		c = fgetc(in);
	}
	lc = 1;
	buf[0] = bp-1;
	for (i=0; i<bp; i++) {
		fprintf(out, " %3d", buf[i]);
		if (++lc > 17) {
			fputc('\n', out);
			lc = 0;
		}
	}
	fputc('\n', out);
	return(0);
}
