///////////////////////////////////////////////////////////////////////////////
//
//	The BSL Compiler Kit
//	BSL Runtime Library: I/O-Streams
//	Copyright (C) 1995 Nils M. Holm
//
//	SCREATE ( MODE )
//
//	PURPOSE:	Create an I/O-Stream
//	RECEIVES:	MODE	- access mode: see IOS.HDR
//	RETURNS:	A pointer to a dynamically allocated IOS
//			structure, or zero in case of an error
//			(insufficient memory, bad mode).
//
//	NOTES:		The IOS-functions require the dynamic memory
//			manager, so MMINIT() must be called before
//			using any IOS-functions.
//			SCREATE() does not open a file; IOS_FD is
//			undefined when it returns.
//

#include( blib.hdr)
#include( ../opt.hdr)
#include( ../sys/syscall.hdr)
#include( ../mem/mem.hdr)

#define( EXTERN(x),)
#include( ios.hdr)
#undefine(EXTERN)

public screate(mode) {
	var	ios;

	if (!(mode & S_RDWR) || mode & ~_S_MASK) return 0;

	if (!(ios = malloc(IOSTREAM))) return 0;

	if (!(ios.ios_buf = malloc(BUFLEN))) {
		mfree(ios);
		return 0;
	}

	ios.ios_flags = mode;
	ios.ios_bsize = BUFLEN;
	ios.ios_ubuf = ENDSTREAM;
	ios.ios_ptr = ios.ios_end = ios.ios_buf;

	return ios;
}
