///////////////////////////////////////////////////////////////////////////////
//
//	The BSL Compiler Kit
//	BSL Runtime Library: I/O-Streams
//	Copyright (C) 1995 Nils M. Holm
//
//	SGETL ( IOS, BUFFER, LENGTH )
//
//	PURPOSE:	Read a line from an IOStream
//	RECEIVES:	IOS	- Stream to read
//			BUFFER	- Where to place the line
//			LENGTH	- Max. number of characters to read.
//	RETURNS:	A pointer to BUFFER.
//			When the EOF has been reached *before*
//			the call to SGETL(), ENDSTREAM will be returned.
//			ENDSTREAM will also be returned in case of
//			an error.
//
//	NOTES:		The IOS-functions require the dynamic memory
//			manager, so MMINIT() must be called before
//			using any IOS-functions.
//

#include( blib.hdr)
#include( ../opt.hdr)

#define( EXTERN(x),)
#include( ios.hdr)
#undefine(EXTERN)

extern	smore;

public sgetl(ios, buffer, length) {
	var	pbuffer = buffer;
	var	c;

	if (#seof(ios)) return ENDSTREAM;

	while (1) {
		if (!(length -= 1)) break;
		c = #sgetc(ios);
		if (#seof(ios)) break;
		.buffer = c; buffer += 1;
		if (c == '\n') break;
	}
	.buffer = 0;

	return pbuffer;
}
