///////////////////////////////////////////////////////////////////////////////
//
//	The BSL Compiler Kit
//	BSL Runtime Library: I/O-Streams
//	Copyright (C) 1995 Nils M. Holm
//
//	SREADF ( IOS, FORMAT, ARGS ... )
//
//	PURPOSE:	Extract objects from an IOStream.
//	RECEIVES:	IOS	- Stream to scan
//			FORMAT	- Description of objects to extract
//			ARGS	- Pointers to variables that will hold
//				the extracted objects.
//	RETURNS:	The number of extracted items, or ENDSTREAM
//			on EOF.
//
//	NOTES:		The IOS-functions require the dynamic memory
//			manager, so MMINIT() must be called before
//			using any IOS-functions.
//

#include( blib.hdr)
#include( ../opt.hdr)

#define( EXTERN(x),)
#include( ios.hdr)
#undefine(EXTERN)

extern	sgetl, vscan;

public sreadf(ios, format, args) {
	var	lbuf.256;

	if (sgetl(ios, lbuf, 256) == ENDSTREAM) return ENDSTREAM;
	return vscan(lbuf, format, @args);
}
