///////////////////////////////////////////////////////////////////////////////
//
//	The BSL Compiler Kit
//	BSL Runtime Library: I/O-Streams
//	Copyright (C) 1995 Nils M. Holm
//
//	STDCLOSE ( )
//
//	PURPOSE:	Sync+close the standard I/O-Streams
//	RECEIVES:	-
//	RETURNS:	0 = Success, ENSDTREAM = SCLOSE() failed.
//
//	NOTES:		STDCLOSE() should be called at the end of
//			each program that uses the standard IOStreams
//			to get sure that the I/O buffers will be
//			flushed.
//
//			The IOS-functions require the dynamic memory
//			manager, so MMINIT() must be called before
//			using any IOS-functions.
//

#include( blib.hdr)
#include( ../opt.hdr)

#define( EXTERN(x),)
#include( ios.hdr)
#undefine(EXTERN)

extern	sclose;
extern	STDIN, STDOUT, STDERR;

public stdclose() {
	var	r = 0;

	r |= sclose(STDIN);
	r |= sclose(STDOUT);
	r |= sclose(STDERR);
	return r;
}
