///////////////////////////////////////////////////////////////////////////////
//
//	The BSL Compiler Kit
//	BSL Runtime Library: Memory Manipulation
//	Copyright (C) 1995 Nils M. Holm
//
//	BPACK ( SOURCE, DEST, LENGTH )
//
//	PURPOSE:	Pack a memory region
//	RECEIVES:	SOURCE	- Region to be packed
//			DEST	- Where to place the packed region
//			LENGTH	- Number of WORDS to pack
//	RETURNS:	Nothing
//
//	NOTES:		THIS CODE WORKS ONLY ON 16-BIT MACHINES.
//

#include( blib.hdr)
#include( ../opt.hdr)

public bpack(source, dest, length) {
	length = length+1 >> 1;
	while (length) {
		length -= 1;
		.dest = .source | .(source+1) << 8;
		dest += 1;
		source += 2;
	}
}
