///////////////////////////////////////////////////////////////////////////////
//
//	The BSL Compiler Kit
//	BSL Runtime Library: Memory Manipulation
//	Copyright (C) 1995 Nils M. Holm
//
//	BUNPACK ( SOURCE, DEST, LENGTH )
//
//	PURPOSE:	Unpack a memory region
//	RECEIVES:	SOURCE	- Region to be unpacked
//			DEST	- Where to place the unpacked region
//			LENGTH	- Number of BYTES to unpack
//	RETURNS:	Nothing
//
//	NOTES:		THIS CODE WORKS ONLY ON 16-BIT MACHINES.
//

#include( blib.hdr)
#include( ../opt.hdr)

public bunpack(source, dest, length) {
	while (length) {
		.dest = .source & 0xff;
		if (!(length -= 1)) break;
		.(dest+1) = .source >> 8;
		length -= 1;
		dest += 2;
		source += 1;
	}
}
