///////////////////////////////////////////////////////////////////////////////
//
//	The BSL Compiler Kit
//	BSL Runtime Library: String Functions
//	Copyright (C) 1995 Nils M. Holm
//
//	STOB ( STRING, BASE )
//
//	PURPOSE:	Convert string to binary.
//	RECEIVES:	STRING	- String to convert.
//			BASE	- Numeric base of STRING.
//	RETURNS:	The binary value represented by STRING. No error
//			checking is done. STOB() stops at the first
//			non-numeric position.
//			BASE must be > 1 and < 17.
//			Both, the upper and lower case letters a...f may
//			be used in STRING, when BASE > 10.
//

#include( blib.hdr)
#include( ../opt.hdr)

extern	bscan, toupper;

public stob(string, base) {
	var	digits = "0123456789ABCDEF";
	var	n = 0, p, sign = 0;

	while (.string == '\s' || .string == '\t') string += 1;

	if (.string == '-') {
		string += 1;
		sign = -1;
	}
	else if (.string == '+') {
		string += 1;
	}

	while (1) {
		p = toupper(.string);
		if ((p = bscan(digits, p, base)) == 0) break;
		n = n * base + p-digits;
		string += 1;
	}

	return sign-> -n, n;
}
