///////////////////////////////////////////////////////////////////////////////
//
//	The BSL Compiler Kit
//	BSL/86 Runtime Library: System Call Interface
//	Copyright (C) 1995 Nils M. Holm
//
//	SYS_FSIZE ( NAME, LENHP, LENLP)
//
//	PURPOSE:	Determine the length of a file
//	RECEIVES:	NAME	- file to measure
//			LENHP	- Pointer to high word of file length
//			LENLP	- Pointer to low word of file length
//	RETURNS:	Zero = success, <0 = failure
//

#include( blib.hdr)
#include( ../opt.hdr)

public sys_fsize(name, lenhp, lenlp) {
	var	regs.REGISTERS;
	var	buf._PATHL_/_BPW_;
	var	fd;

	regs.R_AX = 0x3D00;
	pack(name, buf);
	regs.R_DX = buf * _BPW_;
	regs.R_CX = 0;
	if (__sys(_SYSINT_, regs) & 1) return -regs.R_AX;
	fd = regs.R_AX;

	regs.R_AX = 0x4202;
	regs.R_BX = fd;
	regs.R_CX = regs.R_DX = 0;
	if (__sys(_SYSINT_, regs) & 1) return -regs.R_AX;

	.lenhp = regs.R_DX;
	.lenlp = regs.R_AX;

	regs.R_AX = 0x3E00;
	regs.R_BX = fd;
	if (__sys(_SYSINT_, regs) & 1) return -regs.R_AX;

	return 0;
}
