///////////////////////////////////////////////////////////////////////////////
//
//	The BSL Compiler Kit
//	BSL/86 Runtime Library: System Call Interface
//	Copyright (C) 1995 Nils M. Holm
//
//	SYS_GETCWD ( PATH )
//
//	PURPOSE:	Determine the Current Working Directory
//	RECEIVES:	PATH	- Pointer to a buffer for the CWD
//	RETURNS:	0 = success, -N = error (N is a DOS error code)
//	NOTES:		PATH must provide enough space for a path
//			name -- at least _PATHL_ MACHINE WORDS.
//			The CWD is stored in BSL format (unpacked).
//

#include( blib.hdr)
#include( ../opt.hdr)

public sys_getcwd(path) {
	var	regs.REGISTERS;
	var	pbuf.81;

	regs.R_AX = 0x4700;
	regs.R_DX = 0;
	regs.R_SI = pbuf * _BPW_;
	if (__sys(_SYSINT_, regs) & 1) return -regs.R_AX;
	unpack(pbuf, path);
	return 0;
}
