///////////////////////////////////////////////////////////////////////////////
//
//	The BSL Compiler Kit
//	BSL/86 Runtime Library: System Call Interface
//	Copyright (C) 1995 Nils M. Holm
//
//	SYS_OPEN ( NAME, MODE )
//
//	PURPOSE:	Open an existing file
//	RECEIVES:	NAME	- file to open
//			MODE	- open mode: 0=read, 1=write, 2=both
//	RETURNS:	A file descriptor, or -N in case of an error
//			where N is a DOS error code.
//	NOTES:		The file will be opened in compatibility mode,
//			and with the inherit bit set (child processes
//			have access to the file).
//

#include( blib.hdr)
#include( ../opt.hdr)

public sys_open(name, mode) {
	var	regs.REGISTERS;
	var	buf._PATHL_/_BPW_;

	if (mode < 0 || mode > 2) return -1;
	regs.R_AX = 0x3D00 | mode;
	pack(name, buf);
	regs.R_DX = buf * _BPW_;
	regs.R_CX = 0;
	if (__sys(_SYSINT_, regs) & 1) return -regs.R_AX;
	return regs.R_AX;
}
