///////////////////////////////////////////////////////////////////////////////
//
//	The BSL Compiler Kit
//	BSL/86 Runtime Library: System Call Interface
//	Copyright (C) 1995 Nils M. Holm
//
//	SYS_READ ( FD, BUFFER, LENGTH )
//
//	PURPOSE:	Read a block from an open FD
//	RECEIVES:	FD	- FD of file/device to read
//			BUFFER	- Read buffer
//			LENGTH	- Number of BYTES to read
//	RETURNS:	The number of BYTES read on success,
//			-N in case of an error (N=DOS error code)
//

#include( blib.hdr)
#include( ../opt.hdr)

public sys_read(fd, buffer, length) {
	var	regs.REGISTERS;

	regs.R_AX = 0x3F00;
	regs.R_BX = fd;
	regs.R_CX = length;
	regs.R_DX = buffer * _BPW_;
	if (__sys(_SYSINT_, regs) & 1) return -regs.R_AX;
	return regs.R_AX;
}
