///////////////////////////////////////////////////////////////////////////////
//
//	The BSL Compiler Kit
//	BSL/86 Runtime Library: System Call Interface
//	Copyright (C) 1995 Nils M. Holm
//
//	SYS_RENAME ( OLDNAME, NEWNAME )
//
//	PURPOSE:	Renames a file
//	RECEIVES:	OLDNAME	- path of file to rename
//			NEWNAME - new path
//	RETURNS:	0 = success, -N = error (N is a DOS error code)
//	NOTES:		OLDNAME and NEWNAME must be on the same
//			physical device. NEWNAME must not exist.
//

#include( blib.hdr)
#include( ../opt.hdr)

public sys_rename(oldname, newname) {
	var	regs.REGISTERS;
	var	obuf._PATHL_/_BPW_,
		nbuf._PATHL_/_BPW_;

	regs.R_AX = 0x5600;
	pack(oldname, obuf);
	regs.R_DX = obuf * _BPW_;
	pack(newname, nbuf);
	regs.R_DI = nbuf * _BPW_;
	if (__sys(_SYSINT_, regs) & 1) return -regs.R_AX;
	return 0;
}
