///////////////////////////////////////////////////////////////////////////////
//
//	The BSL Compiler Kit
//	BSL/86 Runtime Library: System Call Interface
//	Copyright (C) 1995 Nils M. Holm
//
//	SYS_SEEK ( FD, POS, SIZE, HOW )
//
//	PURPOSE:	Move file pointer to a specific offset
//	RECEIVES:	FD	- FD whose file pointer is to be moved
//			POS	- New position
//			HOW	- Method: 0=from top, 1=relative, 2=from EOF
//	RETURNS:	0 = success, -N = error (N is a DOS error code)
//

#include( blib.hdr)
#include( ../opt.hdr)

public sys_seek(fd, pos, how) {
	var	regs.REGISTERS;

	if (how < 0 || how > 2) return -1;
	regs.R_AX = 0x4200 | how;
	regs.R_BX = fd;
	regs.R_CX = 0;
	regs.R_DX = pos;
	if (__sys(_SYSINT_, regs) & 1) return -regs.R_AX;
	return 0;
}
